package com.yuandian.dataflow.controller;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.alipay.sofa.jraft.Status;
import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.error.RemotingException;
import com.yuandian.dataflow.projo.Response;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.SyncClosure;
import com.yuandian.dataflow.statemachine.state.State;
import com.yuandian.dataflow.statemachine.state.WorkerState;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class TaskLog {

	@GetMapping(path = "/test")
	public ResponseEntity<Response> Processing() throws InterruptedException, RemotingException {
		// var ws = new WorkerState(new PeerId());
		// StateServerFactory.getStateServer().updateFsmWorkerState(ws);
		Response response = new Response();
		StateServerFactory.getStateServer().useFsmState((fsmState)->{
			log.debug(fsmState.toString() );
			log.debug( StateServerFactory.getNode().getLeaderId().toString() );
			response.Message = fsmState.toString();
			return null;
		});
		response.Code = HttpStatus.OK;
		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}

	@GetMapping(path = "/test2")
	public ResponseEntity<Response> MongodbTest() {
		Response response = new Response();
		StateServerFactory.getStateServer().useFsmStateAsync((fsmState)->{
			log.debug("{} {}", fsmState.toString());
			// response.Message = fsmState.toString();
			return null;
		});

		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}


	@GetMapping(path = "/test3")
	public ResponseEntity<Response> RemoveLeader() {
		Response response = new Response();
		StateServerFactory.getNode().shutdown();
		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}
}
